Subject: WPD-6, WAA-8, and WAA-9 of draft-ietf-v6ops-ipv6-cpe-router-04

From: Philip Homburg <[email-masked]>
Date: Thu, 01 Apr 2010 15:19:49 +0200

WPD-6:
    Absent of other routing information the IPv6 CE router MUST
    use Router Discovery as specified in [RFC4861] to discover a
    default router(s) and install default route(s) in its routing
    table with the discovered router's address as the next-hop.

RFC-4861 describes how routers process Router Advertisements (mainly to
check them for consistency). Only hosts maintain a list of default routers.

It seems strange to me that a BCP mandates behavior that doesn't seem to be
covered by any of the standard track RFCs. If using router advertisements
to provide low-end routers with a default route is a desirable model, then
maybe there should be an RFC for that.

It looks like that at least one ISP treats this draft BCP as gospel. So I 
wonder whether the draft should mandate the weak host model. I can't think
of anything negative that would happen if a CPE assigns in WAA-8 the address
not to a virtual interface but to its WAN interface and then implements the
strong model.

---

From: Ole Troan <[email-masked]>
Date: Thu, 1 Apr 2010 16:46:44 +0200

> check them for consistency). Only hosts maintain a list of default routers.

that's why the upstream interface is specified as behaving as a host for some functions. see W-1.

> maybe there should be an RFC for that.

targeted for Informational, but anyway.
yes, that a 'router' does SLAAC or router discovery caused quite a bit of head ache. the proposed way around that is to define that a home-gateway behaves as a host for certain functions while still forwarding packets.

note that the mechanism in WPD-6 suggests Router Discovery as a last resort.

> not to a virtual interface but to its WAN interface and then implements the

that would violate rfc3633. which require that a delegated prefix isn't used on the link between the RR and the DR. routers are generally following the weak host model, any particular reason why you require the strong host model?

cheers,
Ole

---

From: Philip Homburg <[email-masked]>
Date: Thu, 01 Apr 2010 21:39:06 +0200

> part       text/plain                1708

For acquiring a global address. It doesn't say anything about after that. Does
it remain a host until a default route is installed? How does it handle 
expiring the router router. Or is the first router that replies installed there
forever?

> that would violate rfc3633. which require that a delegated prefix
> isn't used on the link between the RR and the DR. routers are
> generally following the weak host model, any particular reason why
> you require the strong host model?

I never expected a DHCP RFC to effectively mandate the weak multi host model.
Weird.

Because the CPE is essentially always-on it is very tempting to add other host
functionality, like a file server, a web server for the customers's pictures
and videos, maybe a SIP gateway, etc. As such it may acquire other prefixes
as well, maybe ULA, maybe as part of multi homing, prefixes from other
providers.

With the strong host model, you know from with interface addresses are going to
be selected for sending error ICMPs. With the weak multi homing model it is
anyones guess.

How do prevent to router from using the wrong address for sending an error
ICMP?

---

From: Ole Troan <[email-masked]>
Date: Fri, 2 Apr 2010 01:37:05 +0200

Philip,

> expiring the router router. Or is the first router that replies installed there

for the purpose of acquiring an address it will behave like a host. equally with expiring a router learnt via router discovery. of course it is acting as a router for all other purposes.

I'm not that keen on using router discovery either, but as a last resort do you have any better idea?

> I never expected a DHCP RFC to effectively mandate the weak multi host model.

it doesn't. the need for the 'unnumbered' WAN interface does.
I don't know of any router implementation which doesn't implement the weak host model, but I'm not aware of that being specified anywhere either.

> How do prevent to router from using the wrong address for sending an error

it will pick the best source for the purpose, see RFC4443. just like any other multi-homed implementation. see also rfc3484.

cheers,
Ole

---

From: "Wes Beebee (wbeebee)" <[email-masked]>
Date: Fri, 2 Apr 2010 07:49:24 -0500

> I don't know of any router implementation which doesn't implement the
weak host model, but I'm not 
> aware of that being specified anywhere either.

Shin Miyakawa from NTT explained to me one time that they had people
implementing CPE routers based on a Windows Vista stack that used the
strong host model.  This presented quite some difficulty for NTT as an
operator - as they had to restrict themselves in what they could do in
terms of address space conservation in order to support a strong host
model CPE router - and this warning was in a previous version of the CPE
router specification.  We should actively discourage people from
building and using strong host model CPE routers.

This was the previous text:

"The Unnumbered model is incompatible with the strong host model
[RFC1122] on the CPE router.  The unnumbered model may be inappropriate
for use with certain deployments where a device that uses the strong
host model can operate as a CPE router."

- Wes

---

From: "Wes Beebee (wbeebee)" <[email-masked]>
Date: Mon, 5 Apr 2010 08:45:59 -0500

>>This presented quite some difficulty for NTT as an operator - as they 
>>had to restrict themselves in what they could do in terms of address 
>>space conservation in order to support a strong host model CPE router
- 
>>and this warning was in a previous version of the CPE router 
>>specification.  We should actively discourage people from building and

>>using strong host model CPE routers.
>
>I guess I'm missing something obvious here.
>
>An unnumbered link can only occur i.c.w. prefix delegation (otherwise
the CPE wouln't have any 
>addresses at all).
>
>Now instead of assigning an address from its prefix to a virtual
interface, the CPE assigns the
> address to the uplink interface.
>
>This allows the CPE to implement the strong host model, and doesn't
require any cooperation from
> the ISP.
>
>So, what is wrong with that scenario?

Section 12.1 of RFC 3633 forbids it:

"the requesting router MUST NOT assign any delegated prefixes or subnets
from the delegated prefix(es) to the link through which it received the
DHCP message from the delegating router."

- Wes